//=============================================================================
//  Lazarus 関係サンプル
//  Lazarus 用の二重起動防止用コンポーネント TUniqueInstance を使用する例
//
//-----------------------------------------------------------------------------
//
//  【使用条件等】
//
//  当サイトのアプリケーション類，コンポーネント，コード類は，転載，改変，配布
//  (オリジナル，改変版)などは全て自由です．商用利用も自由です．連絡，使用の記
//  載義務もありません．ただしオリジナルそのものを商用とすることは禁止します．
//  なお，本サイトのプログラムやコードを使用したことによって生じた，いかなる障
//  害，損失に関しても作者は一切関与しないものとします．ご了承下さい．
//
//-----------------------------------------------------------------------------
//
//  【履歴】
//
//  2020年07月11日 ～
//
//-----------------------------------------------------------------------------
//
//  【動作確認環境】
//
//  Windows 7 U64(SP1) + lazarus-2.0.8
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls,
  UniqueInstance, Windows;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    UniqueInstance1: TUniqueInstance;
    procedure UniqueInstance1OtherInstance(Sender: TObject;
      ParamCount: Integer; const Parameters: array of String);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

//=============================================================================
//  UniqueInstance1 の OnOtherInstance イベント処理
//  起動中の EXE を起動しようとすると発生する
//  引数は EXE のコマンドラインの数とその値
//
//  オブジェクトインスペクタで以下を設定
//  Enabled        : True (二重起動防止を有効にする)
//  Identifier     : MyHogeLazarusApp (EXE 識別用のユニークな文字列)
//  UpdateInterval : 1000 (イベント発生間隔．Windows では無効)
//
//  ShowMessage のダイアログはアクティブにはならない (筆者の環境では)
//=============================================================================
procedure TForm1.UniqueInstance1OtherInstance(Sender: TObject;
  ParamCount: Integer; const Parameters: array of String);
begin
  FormStyle := fsSystemStayOnTop;
  FormStyle := fsNormal;
  ShowMessage('このアプリは既に起動しています');
end;

end.
