//=============================================================================
//  Lazarus 関係サンプル
//  Halbow 資料館の二重起動禁止コンポーネント TOneInstance を使用する例
//
//-----------------------------------------------------------------------------
//
//  【使用条件等】
//
//  当サイトのアプリケーション類，コンポーネント，コード類は，転載，改変，配布
//  (オリジナル，改変版)などは全て自由です．商用利用も自由です．連絡，使用の記
//  載義務もありません．ただしオリジナルそのものを商用とすることは禁止します．
//  なお，本サイトのプログラムやコードを使用したことによって生じた，いかなる障
//  害，損失に関しても作者は一切関与しないものとします．ご了承下さい．
//
//-----------------------------------------------------------------------------
//
//  【履歴】
//
//  2020年07月11日 ～
//
//-----------------------------------------------------------------------------
//
//  【動作確認環境】
//
//  Windows 7 U64(SP1) + lazarus-2.0.8
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, OneInstance;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    OneInstance1: TOneInstance;
    procedure OneInstance1PrevInstanceExist(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

//=============================================================================
//  OneInstance1 の OnPrevInstanceExist イベント処理
//  起動中の EXE を起動する時に発生する
//
//  オブジェクトインスペクタで以下を設定
//  UniqueName  : EXE 識別用のユニークな文字列
//=============================================================================
procedure TForm1.OneInstance1PrevInstanceExist(Sender: TObject);
begin
  ShowMessage('このアプリは二重起動できません');
  OneInstance1.ActivatePrevApp;
end;

end.

