unit OneInstance;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, Windows, win32int;

type
  TOneInstance = class(TComponent)
  private
    FUniqueName:string;
    FOnPrevInstanceExist:TNotifyEvent;
    FAllocWnd:HWND;
  protected
    procedure AllocWnd(var Message: TMessage);
    function IsPrevAppExist:Boolean;virtual;
  public
    constructor Create(AOwner: TComponent);override;
    destructor Destroy; override;
    procedure ActivatePrevApp;
  published
    property UniqueName:string read FUniqueName write FUniqueName;
    property OnPrevInstanceExist:TNotifyEvent read FOnPrevInstanceExist
                                              write FOnPrevInstanceExist;
  end;

  procedure Register;

  implementation

procedure Register;
begin
  RegisterComponents('System',[TOneInstance]);
end;

  { TOneInstance }

constructor TOneInstance.Create(AOwner: TComponent);
type
  PWndMethod = ^TWndMethod;
begin
  inherited;
  FUniqueName := 'HogeHogeApp123';
  if csDesigning in ComponentState then exit;
  FAllocWnd := Win32WidgetSet.AllocateHWnd(@AllocWnd);
  PostMessage(FAllocWnd,WM_USER+200,0,0);
end;

destructor TOneInstance.Destroy;
begin
  Win32WidgetSet.DeallocateHWnd(FAllocWnd);
  RemoveProp(Application.Handle,PChar(FUniqueName));
inherited;
end;

function TOneInstance.IsPrevAppExist: Boolean;
begin
  result := false;
  CreateMutex(nil,true,PChar(FUniqueName));
  if GetLastError = ERROR_ALREADY_EXISTS then
    result := true;
end;

function EnumWndProc(hWindow:HWND;lData:LPARAM):BOOL;stdcall;
begin
  result := true;
  if GetProp(hWindow,PChar(lData)) = 1111 then begin
    if IsIconic(hWindow) then ShowWindow(hWindow,SW_RESTORE);
    SetForegroundWindow(hWindow);
    result := false;
  end;
end;

  procedure TOneInstance.ActivatePrevApp;
  begin
    EnumWindows(@EnumWndProc,LPARAM(PChar(FUniqueName)));
  end;

procedure TOneInstance.AllocWnd(var Message: TMessage);
begin
  if Message.Msg <> WM_USER+200 then exit;
  if IsPrevAppExist then begin
    if Assigned(FOnPrevInstanceExist) then FOnPrevInstanceExist(self);
    PostMessage(Application.Handle,WM_SYSCOMMAND,SC_CLOSE,0);
  end else
    SetProp(Application.Handle,PChar(FUniqueName),1111);
end;

end.
